#include "Model.h"

#include "vk.h"

// Конструктор класса без индексов - принимает массив вершин
Model_wo_indexes::Model_wo_indexes(Vertex* vertexArray, uint32_t count) : verteciesCount(count)
{
    extern Vulkan vulkan;
    // Создание и инициализация буфера   
    vertexBuffer = vulkan.createDataBuffer(vertexArray, verteciesCount * sizeof(Vertex), VK_BUFFER_USAGE_VERTEX_BUFFER_BIT);
}

// Деструктор класса без индексов
Model_wo_indexes::~Model_wo_indexes()
{
    extern Vulkan vulkan;
    
    vulkan.destroyBuffer(vertexBuffer);
}

// Рендер модели без индексов
void Model_wo_indexes::render(VkCommandBuffer commandBuffer)
{
    VkBuffer vertexBuffers[] = {vertexBuffer};
    VkDeviceSize offsets[] = {0};

    vkCmdBindVertexBuffers(commandBuffer, 0, 1, vertexBuffers, offsets);
    vkCmdDraw(commandBuffer, verteciesCount, 1, 0, 0);
}
